Bug 101014 - Keyboard navigation between textboxes not in logical order in various slide layouts
Summary: Keyboard navigation between textboxes not in logical order in various slide l...
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Impress (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium minor
Assignee: Marina Latini (CIB)
URL:
Whiteboard: target:6.1.0 target:6.0.0.1
Keywords: accessibility, needsDevEval
Depends on:
Blocks: a11y Slide-Layout
  Show dependency treegraph
 
Reported: 2016-07-19 14:10 UTC by Alex ARNAUD
Modified: 2018-05-22 13:56 UTC (History)
8 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Alex ARNAUD 2016-07-19 14:10:01 UTC
Dear Libreoffice community,

I'm a blind person and I use keyboard shortcuts to move between elements inside my impress presentatiosn.

At this time, when you add a new slide with the layout "1 title, 6 contents" and you try to move between panel with tab the keyboard caret moves on this order :
1) Title panel
2) Second column, first content panel
3) Second column, second content panel
3) Second column, third content panel
4) Third column, third content panel
5) Third column, second content panel
6) Third column, first content panel

The tab order should be from left to right on each lines for the usability of blind users.

Best regards.
Comment 1 Aron Budea 2016-07-21 07:42:29 UTC
Hi Alex,

Reproduced with LibreOffice 5.1.4.2, and version as early as 3.3.0.
There's the same issue with "Title, 4 Content" layout.

This should be simple enough to be an easy hack, adding needsDevEval keyword to report. Also adjusting severity to minor, as the bug does not prevent high quality work.
Comment 2 Yousuf Philips (jay) (retired) 2016-09-05 17:57:29 UTC
Not sure its in a good order when its 'Title, 2 content and content' either.
Comment 3 Xisco Faulí 2017-09-29 08:48:47 UTC Comment hidden (obsolete)
Comment 4 Alex ARNAUD 2017-10-03 12:35:40 UTC
Dear all,

I can reproduce this issue on LibreOfficeDev 6.0 build of 2017-09-27 on Debian 8.9 "Jessie".

Best regards.
Comment 5 Marina Latini (CIB) 2017-11-30 23:17:55 UTC
Hi all,
I would work on this report.
Comment 6 Commit Notification 2017-12-01 16:40:17 UTC
Marina Latini committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=dccfe8765c25caf8485e659711a6df6c43ed63a9

tdf#101014 Keyboard navigation between textboxes

It will be available in 6.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Yousuf Philips (jay) (retired) 2017-12-02 08:21:02 UTC
I think the order should also be changed for 'Title, 2 Content and Content', so its a1, b1+b2, a2 rather than the current a1, a2, b1+b2.
Comment 8 Marina Latini (CIB) 2017-12-05 17:48:32 UTC
(In reply to Yousuf Philips (jay) from comment #7)
> I think the order should also be changed for 'Title, 2 Content and Content',
> so its a1, b1+b2, a2 rather than the current a1, a2, b1+b2.

yep, U're right.
new patch submitted for review to gerrit.
Comment 9 Marina Latini (CIB) 2017-12-06 08:10:06 UTC
@Alex:
I have not sure about the proper order of the vertical layouts:
* "Vertical Title, Text, Chart"
* "Vertical Title, Vertical Text"
For me they seems correct but, please, can you confirm that are ok for you?

Thanks,
Marina
Comment 10 Katarina Behrens (CIB) 2017-12-06 10:07:52 UTC
> I think the order should also be changed for 'Title, 2 Content and Content',
> so its a1, b1+b2, a2 rather than the current a1, a2, b1+b2.

@Jay, you sure about this in LTR environment?

Where: 
a1 = title
b1 = upper left small textbox
b2 = lower left small textbox
a2 = right big textbox

a1, b1, b2, a2 is the navigation order I would expect ... but can someone please x-check this
Comment 11 Katarina Behrens (CIB) 2017-12-06 10:16:43 UTC
... to continue: this -- a1, b1, b2, a2 is how it is currently implemented. 

deneb_alpha's patch changes this to a1, a2, b1, b2, which makes less sense to me, but I might be a wrong reference frame
Comment 12 Alex ARNAUD 2017-12-06 10:31:21 UTC
(In reply to Katarina Behrens (CIB) from comment #11)
> ... to continue: this -- a1, b1, b2, a2 is how it is currently implemented. 
> 
> deneb_alpha's patch changes this to a1, a2, b1, b2, which makes less sense
> to me, but I might be a wrong reference frame

The current implementation seems OK to me for this particular case.

Best regards.
Comment 13 Alex ARNAUD 2017-12-06 11:19:01 UTC
(In reply to Marina Latini from comment #9)
> @Alex:
> I have not sure about the proper order of the vertical layouts:
> * "Vertical Title, Text, Chart"
> * "Vertical Title, Vertical Text"
> For me they seems correct but, please, can you confirm that are ok for you?
> 
> Thanks,
> Marina

Thank for your contribution on this bug.

I've tested the vertical layout and I confirm it looks correct to me.

Best regards.
Comment 14 Commit Notification 2017-12-06 13:26:03 UTC
Marina Latini committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=1623caf67a0670f332fc45b9f25aac8818cad9a6

tdf#101014 Keyboard between textboxes - part 2

It will be available in 6.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 15 Yousuf Philips (jay) (retired) 2017-12-06 14:37:28 UTC
(In reply to Marina Latini from comment #9)
> I have not sure about the proper order of the vertical layouts:
> * "Vertical Title, Text, Chart"
> * "Vertical Title, Vertical Text"
> For me they seems correct but, please, can you confirm that are ok for you?

I had tested these and they were fine.

(In reply to Katarina Behrens (CIB) from comment #10)
> @Jay, you sure about this in LTR environment?

My 'a1, b1+b2, a2' was excluding the title, so

a1 = upper left small textbox
b1+b2 = right big textbox
a2 = lower left small textbox
Comment 16 Marina Latini (CIB) 2017-12-13 13:42:39 UTC
@Arnaud @Jay: if the fix looks good to you, I would close this bugreport.

Thanks,
Marina
Comment 17 Yousuf Philips (jay) (retired) 2017-12-13 19:37:25 UTC
(In reply to Marina Latini from comment #16)
> @Arnaud @Jay: if the fix looks good to you, I would close this bugreport.

Looks good to me, just needs to be backported to 6.0.

Version: 6.1.0.0.alpha0+
Build ID: 4af729f31c64c09c76ea8bcfa5067092571b92de
CPU threads: 2; OS: Linux 4.4; UI render: default; VCL: gtk2; 
TinderBox: Linux-rpm_deb-x86_64@70-TDF, Branch:master, Time: 2017-12-13_14:37:55
Locale: en-US (en_US.UTF-8); Calc: group threaded
Comment 18 Commit Notification 2017-12-14 12:28:41 UTC
Marina Latini committed a patch related to this issue.
It has been pushed to "libreoffice-6-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=08d050776d98022591ec55ea19850b68280b768e&h=libreoffice-6-0

tdf#101014 Keyboard navigation between textboxes

It will be available in 6.0.0.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 19 Commit Notification 2017-12-14 12:28:48 UTC
Marina Latini committed a patch related to this issue.
It has been pushed to "libreoffice-6-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=8582e9a837eb5bcf69ea5f82611e4a8cc3e67b98&h=libreoffice-6-0

tdf#101014 Keyboard between textboxes - part 2

It will be available in 6.0.0.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 20 Alex ARNAUD 2017-12-15 12:45:05 UTC
(In reply to Marina Latini from comment #16)
> @Arnaud @Jay: if the fix looks good to you, I would close this bugreport.
> 
> Thanks,
> Marina

I've tested LibreOfficeDev 6.1 built the 2017-12-11 on Debian 8 and it works great.

Thank you very much for this fix Marina :) !

Best regards.